Subject: Re: [PATCH net-next v2] tls: Add opt-in zerocopy mode of sendfile()

From: Jakub Kicinski <[email-masked]>
Date: Fri, 13 May 2022 09:02:13 -0700

On Fri, 13 May 2022 10:57:06 +0300 Maxim Mikityanskiy wrote:
> > What about the reporting via sock diag? Am I misremembering something?  
> 
> I recall we discussed that "zerocopy is active" can be restored as 
> "hardware offload && setsockopt flag requested", and I saw that 
> tls_get_info exposes the hardware offload state for the socket, so I 
> thought the existing information in sock_diag was enough.
> 
> If you think, though, that it will be better to have an explicit 
> indication of the zerocopy flag to sock_diag, I can add it, it's not a 
> problem.

Yeah, my thinking is that if a user reports problems to me I'd like to
be able to log in to the box and see what they have configured on the
socket. ss is quick and easy to type. I'm not aware of tooling that'd
grab descriptors for sockets and do getsockopt() (even tho technically
it is doable), are there any? I'm not feeling strong about sock_diag
specifically being the way but for such a potentially correctness-
-impacting optimization we should give admins an easy way to
interrogate if it's enabled or not.

> Does the rest of the patch look good to you?

Yup!